<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Api extends Controller {
	/*
	public function action_get_client_updates()
	{
		$arr_params = $this->request->query();

		// $limit = array_key_exists('numberOfNotifications', $arr_params) ? $arr_params['numberOfNotifications'] : 10;

		// default to personal on first load
		if ( ! isset($segment_id))
		{
			$segment_id = 1;
		}

		$current_date = date('Y-m-d', time());

		$sql = DB::select('id', 'control_no', 'title', 'category_id', 'status_date')
			->from('pages')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%");

		if (array_key_exists('numberOfNotifications', $arr_params))
		{
			$sql->limit($arr_params['numberOfNotifications'])
				->offset(0);
		}

		// $qry = $sql->order_by('id', 'DESC')
		$qry = $sql->order_by('status_date', 'DESC')
			->as_object()
			->execute();

		$xml = new SimpleXMLElement('<response/>');

		foreach ($qry as $res)
		{
			$id = $res->id;
			$title = $res->title;
			$url = URL::site('page/client_update/'.$id, true);

			$track = $xml->addChild('url-list');
			$track->addChild('notification', $title);
			$track->addChild('urlnotification', $url);
		}

		$xml->addChild('url-view-more', URL::site('page/client_updates', true));

		$this->response->headers(array('Content-Type'=>'application/xml', 'Cache-Control'=>'no-cache'));
		$this->response->body($xml->asXML());
	}
	*/

	public function action_get_client_updates()
	{
		$current_date = date('Y-m-d', time());

		// personal segment (get latest 5)
		$segment_id = 1;
		$sql = DB::select('id', 'control_no', 'title', 'body1')
			->from('pages')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
			->limit(5)
			->order_by('start_date', 'DESC')
			->as_object()
			->execute();

		// overseas filipino segment
		$segment_id = 5;
		$sql2 = DB::select('id', 'control_no', 'title', 'body1')
			->from('pages')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
			->limit(1)
			->order_by('start_date', 'DESC')
			->as_object()
			->execute();

		$arr_client_updates = array();
		// if there's an OF segment result
		if ($sql2->count())
		{
			$i = 0;
			foreach ($sql as $res)
			{
				if ($i < 4)
				{
					$id = $res->id;
					$title = strip_tags(html_entity_decode($res->title, ENT_QUOTES));
					$body = html_entity_decode($res->body1, ENT_QUOTES);
					if ($body)
					{
						$url = URL::site('cms/page/'.$id.'/'.URL::title($title), true);
					}
					else
					{
						$url = '#';
					}

					$arr_client_updates[$id] = array(
						'title' => $title,
						'url' => $url
					);
				}

				$i++;
			}

			$of = $sql2->current();
			$id = $of->id;
			$title = strip_tags(html_entity_decode($of->title, ENT_QUOTES));
			$body = html_entity_decode($of->body1, ENT_QUOTES);
			if ($body)
			{
				$url = URL::site('cms/page/'.$id.'/'.URL::title($title), true);
			}
			else
			{
				$url = '#';
			}

			if ( ! array_key_exists($id, $arr_client_updates))
			{
				$arr_client_updates[$id] = array(
					'title' => $title,
					'url' => $url
				);
			}
		}
		else
		{
			foreach ($sql as $res)
			{
				$id = $res->id;
				$title = strip_tags(html_entity_decode($res->title, ENT_QUOTES));
				$body = html_entity_decode($res->body1, ENT_QUOTES);
				if ($body)
				{
					$url = URL::site('cms/page/'.$id.'/'.URL::title($title), true);
				}
				else
				{
					$url = '#';
				}

				$arr_client_updates[$id] = array(
					'title' => $title,
					'url' => $url
				);
			}
		}

		$xml = new SimpleXMLElement('<response/>');

		foreach ($arr_client_updates as $k => $v)
		{
			$id = $k;
			$title = $v['title'];
			$url = $v['url'];

			$track = $xml->addChild('url-list');
			$track->addChild('notification', HTML::chars($title));
			$track->addChild('urlnotification', $url);
		}

		$xml->addChild('url-view-more', URL::site('page/client_updates', true));

		$this->response->headers(array('Content-Type'=>'application/xml', 'Cache-Control'=>'no-cache'));
		$this->response->body($xml->asXML());
	}

	public function action_get_ad_banners()
	{
		$keyword = $this->request->query('keyword');

		$str_category = '';
		$str_sub_category1 = '';
		$str_sub_category2 = '';
		$str_sub_category3 = '';

		// exclude Logout Ad Banner
		$sql = DB::select('id')
			->from('categories')
			->where('name', 'LIKE', '%logout%')
			->or_where('name', 'LIKE', '%log out%')
			->as_object()
			->execute();

		$arr_categories = array();
		foreach ($sql as $res)
		{
			$arr_categories[0][] = $res->id;
		}

		$logout_category = '';
		$categs = array();
		foreach ($arr_categories as $level => $arr_categs)
		{
			if ($level == 0)
			{
				// $logout_category = implode(",", $arr_categs);
				$categs = array_merge($categs, $arr_categs);
			}
		}

		if (count($categs)) {
			$logout_category = implode(",", $categs);
		}

		if ($keyword)
		{
			// get list of categories matching the keyword
			$sql = DB::select('id')
				->from('categories')
				->where('name', 'LIKE', '%'.$keyword.'%')
				->as_object()
				->execute();

			$arr_categories = array();
			foreach ($sql as $res)
			{
				$arr_categories[0][] = $res->id;
			}

			// get list from navtree matching the keyword
			$sql = DB::select('id','level')
				->from('navtree')
				->where('name', 'LIKE', '%'.$keyword.'%')
				->as_object()
				->execute();

			foreach ($sql as $res)
			{
				$level = $res->level;
				$arr_categories[$level][] = $res->id;
			}

			foreach ($arr_categories as $level => $arr_categs)
			{
				if ($level == 0)
				{
					$str_category = implode(",", $arr_categs);
				} else if ($level == 1) {
					$str_sub_category1 = implode(",", $arr_categs);
				} else if ($level == 2) {
					$str_sub_category2 = implode(",", $arr_categs);
				} else if ($level == 3) {
					$str_sub_category3 = implode(",", $arr_categs);
				}
			}
		}

		$current_date = date('Y-m-d', time());

		$sql = "SELECT TOP 3 * FROM pages WHERE pages.content_type_id = 3
			AND (pages.status = 'published' OR pages.status = 'request-archive' OR pages.status = 'pending-archive' OR pages.status = 'check-archive' OR pages.status = 'rework-archive')
			AND pages.start_date <= '$current_date'
			AND pages.end_date >= '$current_date'";

		if ($logout_category)
		{
			$sql .= " AND pages.category_id NOT IN ($logout_category)";
		}

		if ($str_category OR $str_sub_category1 OR $str_sub_category2 OR $str_sub_category3)
		{
			$subq = '';
			if ($str_category)
			{
				// $sql->where('category_id', 'IN', DB::expr('('.$str_category.')'));
				$subq .= ($subq ? " OR " : '')." pages.category_id IN ($str_category)";
			}

			if ($str_sub_category1)
			{
				// $sql->where('sub_category1', 'IN', DB::expr('('.$str_sub_category1.')'));
				$subq .= ($subq ? " OR " : '')." pages.sub_category1 IN ($str_sub_category1)";
			}
			/*
			else
			{
				$sql .= " AND (pages.sub_category1 IS NULL OR pages.sub_category1 = 0)";
			}
			*/

			if ($str_sub_category2)
			{
				// $sql->where('sub_category2', 'IN', DB::expr('('.$str_sub_category2.')'));
				$subq .= ($subq ? " OR " : '')." pages.sub_category2 IN ($str_sub_category2)";
			}
			/*
			else
			{
				$sql .= " AND (pages.sub_category2 IS NULL OR pages.sub_category2 = 0)";
			}
			*/

			if ($str_sub_category3)
			{
				// $sql->where('sub_category3', 'IN', DB::expr('('.$str_sub_category3.')'));
				$subq .= ($subq ? " OR " : '')." pages.sub_category3 IN ($str_sub_category3)";
			}
			/*
			else
			{
				$sql .= " AND (pages.sub_category3 IS NULL OR pages.sub_category3 = 0)";
			}
			*/

			$sql .= $subq ? " AND (".$subq.")" : '';
		}

		// $sql .= " AND (ABS(CAST((BINARY_CHECKSUM(*) * RAND()) as int)) % 100) < 70";
		$sql .= " ORDER BY NEWID()";
		$query = DB::query(Database::SELECT, $sql);
		$qry = $query->as_object()->execute();

		$this->response->headers(array('Content-Type'=>'application/json', 'Cache-Control'=>'no-cache'));
		if ($qry->count())
		{
			$ads = array();
			foreach ($qry as $ad)
			{
				$ads[] = array(
					'ad_link' =>  $ad->link1 ? $ad->link1 : '',
					'ad_src' => URL::site('media/uploads/'.$ad->image1, true),
					'ad_title' => html_entity_decode($ad->title)
				);
			}

			$json = json_encode($ads);

			$this->response->body($json);
		}
		else
		{
			$this->response->body(json_encode(false));
		}
	}

	public function action_get_logout_ad()
	{
		// get list of categories matching the logout or log out keyword
		$sql = DB::select('id')
			->from('categories')
			->where('name', 'LIKE', '%logout%')
			->or_where('name', 'LIKE', '%log out%')
			->as_object()
			->execute();

		$arr_categories = array();
		foreach ($sql as $res)
		{
			$arr_categories[0][] = $res->id;
		}

		$str_category = '';
		$categs = array();
		foreach ($arr_categories as $level => $arr_categs)
		{
			if ($level == 0)
			{
				// $str_category = implode(",", $arr_categs);
				$categs = array_merge($categs, $arr_categs);
			}
		}

		if (count($categs)) {
			$str_category = implode(",", $categs);
		}

		$current_date = date('Y-m-d', time());

		$sql = "SELECT TOP 1 * FROM pages WHERE pages.content_type_id = 3
			AND (pages.status = 'published' OR pages.status = 'request-archive' OR pages.status = 'pending-archive' OR pages.status = 'check-archive' OR pages.status = 'rework-archive')
			AND pages.start_date <= '$current_date'
			AND pages.end_date >= '$current_date'";

		if ($str_category)
		{
			// $sql->where('category_id', 'IN', DB::expr('('.$str_category.')'));
			$sql .= " AND pages.category_id IN ($str_category)";
		}

		// $sql .= " AND (ABS(CAST((BINARY_CHECKSUM(*) * RAND()) as int)) % 100) < 70";
		$sql .= " ORDER BY NEWID()";
		$query = DB::query(Database::SELECT, $sql);
		$qry = $query->as_object()->execute();

		$this->response->headers(array('Content-Type'=>'application/json', 'Cache-Control'=>'no-cache'));
		if ($qry->count())
		{
			$ad = $qry->current();

			$ads = array(
				'ad_link' =>  $ad->link1 ? $ad->link1 : '',
				'ad_src' => URL::site('media/uploads/'.$ad->image1, true),
				'ad_title' => html_entity_decode($ad->title)
			);

			$json = json_encode($ads);

			$this->response->body($json);
		}
		else
		{
			$this->response->body(json_encode(false));
		}
	}

	public function action_get_splash_page_violator()
	{
		$current_date = date('Y-m-d', time());

		$qry = ORM::factory('Page')
			->where('content_type_id', '=', 6)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->order_by(DB::expr('NEWID()'))
			->find_all();

		$splash_page = array();
		if ($qry->count())
		{
			$stat = true;
			foreach ($qry as $res)
			{
				$id = $res->id;
				$title = html_entity_decode($res->title);
				$body = html_entity_decode($res->body1);

				$splash_page[] = array(
					'title' => $title,
					'link' => URL::site('cms/page/'.$id.'/'.URL::title($title), true)
				);
			}
		}
		else
		{
			$stat = false;
		}

		$data = array(
			'status' => $stat,
			'pages' => $splash_page
		);

		$json = json_encode($data);

		$this->response->headers(array('Content-Type'=>'application/json', 'Cache-Control'=>'no-cache'));
		$this->response->body($json);
	}
}