<?php defined('SYSPATH') or die('No direct script access.');

class Controller_FileUpload extends Controller {

	public function action_index()
	{
		$view = View::factory('fileupload');

		$this->response->body($view);
	}

	/**
	 * Upload a file in the current server and to other Load Balanced server
	 * @return [type] [description]
	 */
	public function action_start()
	{
		$this->auto_render = FALSE;

		$field = $this->request->param('id');
		$type = $this->request->param('id2');

		if( ! empty($_FILES))
		{
			$directory = DOCROOT.'media/uploads';
			$file = '';
			if (isset($_FILES[$field]['name']))
			{
				if ($type == 'doc')
				{
					$files = Validation::factory($_FILES)
						->rules($field, array(
							array('Upload::not_empty'),
							array('Upload::size', array(':value', '5M')),
							array('Upload::type', array(':value', array('pdf'))),
						));
				}
				else
				{
					$files = Validation::factory($_FILES)
						->rules($field, array(
							array('Upload::not_empty'),
							array('Upload::size', array(':value', '5M')),
							array('Upload::type', array(':value', array('gif', 'jpg', 'jpeg', 'png'))),
						));
				}

				if ($files->check())
				{
					$dbserver = Kohana::$config->load('site')->get('dbserver');
					$lbsites = Kohana::$config->load('site')->get('lb_sites');

					// remove previously uploaded file if they try to upload a different file
					$old_file = Arr::get($this->request->post(), 'file_'.$field);
					if ($old_file)
					{
						// remove the old uploaded file
						@unlink($directory.'/'.$old_file);

						if (count($lbsites) > 0)
						{
							$post = array('file_name'=>$old_file);
							foreach ($lbsites as $k => $site)
							{
								$target_url = $site.'/fileupload/file_remove';
								// echo $target_url.' test ';
								$ch = curl_init();
								curl_setopt($ch, CURLOPT_URL, $target_url);
								curl_setopt($ch, CURLOPT_POST, 1);
								curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
								curl_exec ($ch);
								curl_close ($ch);
							}
						}
					}

					$filename  = preg_replace('/\s+/u', '_', $files[$field]['name']);
					$file_name = uniqid().'_'.$filename;

					// Upload!
					$file = Upload::save($files[$field], $file_name, $directory);

					// CURL File Upload
					$post = array('file'=>'@'.$file, 'filename'=>$file_name);
					$curl_error = false;
					$ok_sites = array();
					if (count($lbsites) > 0)
					{
						foreach ($lbsites as $k => $site)
						{
							$target_url = $site.'/fileupload/file_accept';
							// echo $target_url.' test <br />';
							$ch = curl_init();
							curl_setopt($ch, CURLOPT_URL, $target_url);
							curl_setopt($ch, CURLOPT_POST, 1);
							curl_setopt($ch, CURLOPT_POSTFIELDS, $post);

							if(curl_exec($ch) === false)
							{
							   //  echo 'Curl error: ' . curl_error($ch);
							   $curl_error = true;
							   $msg = curl_error($ch).' - '.$site;
								curl_close($ch);
								break;
							}
							else
							{
								$ok_sites[] = $site;
							}
						}
					}

					// if there's an issue with curl upload in one of the load balanced servers
					if ($curl_error)
					{
						// remove the main site uploaded file
						@unlink($directory.'/'.$file_name);

						// remove it also in servers where it was alread uploaded
						if(count($ok_sites) > 0)
						{
							$file_remove = array('file_name'=>$file_name);
							foreach ($ok_sites as $k => $site)
							{
								$target_url = $site.'/fileupload/file_remove';
								// echo $target_url.' test ';
								$ch = curl_init();
								curl_setopt($ch, CURLOPT_URL, $target_url);
								curl_setopt($ch, CURLOPT_POST, 1);
								curl_setopt($ch, CURLOPT_POSTFIELDS, $file_remove);
								$result = curl_exec ($ch);

								curl_close ($ch);
							}
						}

						$result = false;
						$msg = $msg;
					}
					else
					{
						$result = true;
						$msg = $file_name;
					}
				} else {
					$e = $files->errors('custom');
					$result = false;
					$msg = $e[$field];
				}

				$res = array("result" => $result, "msg" => $msg);

				echo json_encode($res);
			}
		}
	}

	/**
	 * Delete an image in the current server and to other Load Balance server
	 * @return [type] [description]
	 * @accept array of filenames to be deleted
	 */
	public function action_file_delete()
	{
		$files = array(
			'53181415937ea_promo_details.png'
		);

		if (is_array($files))
		{
			$directory = DOCROOT.'media/uploads';
			$dbserver = Kohana::$config->load('site')->get('dbserver');
			$lbsites = Kohana::$config->load('site')->get('lb_sites');

			foreach ($files as $file_id => $file_name)
			{
				if (is_file($directory.'/'.$file_name) AND file_exists($directory.'/'.$file_name))
				{
					@unlink($directory.'/'.$file_name);

					// start CURL Delete
					$post = array('file_name'=>$file_name);
					foreach($lbsites as $k => $site)
					{
						$target_url = $site.'/fileupload/file_remove';
						// echo $target_url.' test ';
						$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL, $target_url);
						curl_setopt($ch, CURLOPT_POST, 1);
						curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
						$result = curl_exec ($ch);

						curl_close ($ch);
					}

					/*
					DB::delete('media')
						->where('id', '=', $file_id)
						->execute();
					*/
				}
			}
		}
	}

	/**
	 * Remote server file upload method
	 * @return [type] [description]
	 */
	public function action_file_accept()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$filename = Arr::get($this->request->post(), 'filename');

			$directory = DOCROOT.'media/uploads';

			if( ! empty($_FILES))
			{
				// Upload!
				$file = Upload::save($_FILES['file'], $filename, $directory);
			}
		}
	}

	/**
	 * Remote server file delete method
	 * @return [type] [description]
	 */
	public function action_file_remove()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$directory = DOCROOT.'media/uploads';

			$file_name = Arr::get($this->request->post(), 'file_name');

			if (is_file($directory.'/'.$file_name) AND file_exists($directory.'/'.$file_name))
			{
				@unlink($directory.'/'.$file_name);
			}
		}
	}

	/**
	 * Remote server template file upload method
	 * @return [type] [description]
	 */
	public function action_template_file()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$type = Arr::get($this->request->post(), 'type');

			if ($type == 'tpl_file')
			{
				$directory = DOCROOT.'application/views/templates';
				$filename = Arr::get($this->request->post(), 'filename');

				if( ! empty($_FILES))
				{
					// Upload!
					$file = Upload::save($_FILES['file'], $filename, $directory);
				}
			}
			else if ($type == 'tpl_img')
			{
				$directory = DOCROOT.'media/template';
				$thumbnail = Arr::get($this->request->post(), 'thumbnail_name');
				$main_image = Arr::get($this->request->post(), 'main_img_name');

				if( ! empty($_FILES))
				{
					// Upload template thumbnail
					Upload::save($_FILES['thumbnail'], $thumbnail, $directory);
					// Upload template main image
					Upload::save($_FILES['main_img'], $main_image, $directory);
				}
			}
		}
	}

	/**
	 * Remote server template file remove method
	 * @return [type] [description]
	 */
	public function action_remove_template()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$type = Arr::get($this->request->post(), 'type');

			if ($type == 'tpl_file')
			{
				$directory = DOCROOT.'application/views/templates';
				$filename = Arr::get($this->request->post(), 'filename');
			}
			else if ($type == 'tpl_img')
			{
				$directory = DOCROOT.'media/template';
				$filename = Arr::get($this->request->post(), 'filename');
			}

			if (is_file($directory.'/'.$filename) AND file_exists($directory.'/'.$filename))
			{
				@unlink($directory.'/'.$filename);
			}
		}
	}
}