<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Nav extends Controller {

	public function before()
	{
		parent::before();

		$this->toplinks = array(
			'related_sites' => 'Related Sites',
			'about_us' => 'About Us',
			'apply_now' => 'Apply Now',
			'promos' => 'Promos',
			'rates' => 'Rates',
			'locator' => 'Locator',
			'contact_us' => 'Contact Us',
			'product_services' => 'Product & Services',
			'market_watcher' => 'Market Watcher',
			'careers' => 'Careers',
			'security' => 'Security',
			'preferred_banking' => 'Preferred Banking',
			'private_banking' => 'Private Banking'
		);
	}

	public function action_top_links()
	{
		$label = $this->request->param('id');

		$sql = ORM::factory('TopLink')
			->where('label', '=', $label)
			->find_all();

		$view = '';
		if ($sql->count())
		{
			$c = $sql->current();
			if ($c->type == 'menu')
			// if ($sql->count() > 1)
			{
				$view .= '<li'.(Session::instance()->get('menu_active2') == $label ? ' class="active"' : '').'><a id="'.$label.'" class="menu-main" href="#">'.Arr::get($this->toplinks, $label).'</a><div class="menu-dropdown" id="'.$label.'-dropdown">';
				foreach ($sql as $res)
				{
					if (stristr($res->menu_link, 'info.bpiexpressonline.com'))
					{
						$href_target = ' target="_blank"';
					}
					else if (stristr($res->menu_link, 'bpiexpressonline.com'))
					{
						$href_target = '';
					}
					else{
						$href_target = ' target="_blank"';
					}

					$view .= '<div><a href="'.html_entity_decode($res->menu_link).'" rel="'.$label.'" class="page-link"'.$href_target.'>'.html_entity_decode($res->menu_label).'</a></div>';
				}
				$view .= '</div></li>';
			}
			else
			{
				$res = $sql->current();
				if (stristr($res->page_link, 'info.bpiexpressonline.com'))
				{
					$href_target = ' target="_blank"';
				}
				else if (stristr($res->page_link, 'bpiexpressonline.com'))
				{
					$href_target = '';
				}
				else{
					$href_target = ' target="_blank"';
				}

				if ($label == 'preferred_banking' OR $label == 'private_banking')
				{
					$active = '';
					if ($label == Session::instance()->get('menu_active2'))
					{
						$active = ' current';
					}
					$view .= '<li><a href="'.html_entity_decode($res->page_link).'" id="'.$label.'" class="'.$active.'"'.$href_target.'>'.Arr::get($this->toplinks, $label).'</a></li>';
				}
				else
				{
					$view .= '<li'.(Session::instance()->get('menu_active2') == $label ? ' class="active"' : '').'><a href="'.html_entity_decode($res->page_link).'" rel="'.$label.'" class="page-link"'.$href_target.'>'.Arr::get($this->toplinks, $label).'</a></li>';
				}
			}
		}
		else
		{
			$view .= '<li><a href="#">'.Arr::get($this->toplinks, $label).'</a></li>';
		}

		$this->response->body($view);
	}

	public function action_bottom_links()
	{
		$label = $this->request->param('id');

		$sql = ORM::factory('TopLink')
			->where('label', '=', $label)
			->find_all();

		$view = '';
		if ($sql->count())
		{
			$c = $sql->current();
			if ($c->type == 'menu')
			// if ($sql->count() > 1)
			{
				$view .= '<a id="'.$label.'" class="'.(Session::instance()->get('menu_active3') == $label ? 'active' : '').'" href="#">'.Arr::get($this->toplinks, $label).'</a><div class="menu-dropdown" id="'.$label.'-dropdown">';
				foreach ($sql as $res)
				{
					if (stristr($res->menu_link, 'info.bpiexpressonline.com'))
					{
						$href_target = ' target="_blank"';
					}
					else if (stristr($res->menu_link, 'bpiexpressonline.com'))
					{
						$href_target = '';
					}
					else{
						$href_target = ' target="_blank"';
					}

					$view .= '<div><a href="'.html_entity_decode($res->menu_link).'" class="bottom-links" rel="'.$label.'"'.$href_target.'>'.html_entity_decode($res->menu_label).'</a></div>';
				}
				$view .= '</div>';
			}
			else
			{
				$res = $sql->current();
				if (stristr($res->page_link, 'info.bpiexpressonline.com'))
				{
					$href_target = ' target="_blank"';
				}
				else if (stristr($res->page_link, 'bpiexpressonline.com'))
				{
					$href_target = '';
				}
				else{
					$href_target = ' target="_blank"';
				}
				$view .= '<a href="'.html_entity_decode($res->page_link).'" class="'.(Session::instance()->get('menu_active3') == $label ? 'active' : '').' bottom-links" rel="'.$label.'"'.$href_target.'>'.Arr::get($this->toplinks, $label).'</a>';
			}
		}
		else
		{
			$view .= '<a href="#">'.Arr::get($this->toplinks, $label).'</a>';
		}

		$this->response->body($view);
	}

	public function action_set_active()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$element = Arr::get($this->request->post(), 'element');

			$el = explode("|", $element);

			switch ($el[0])
			{
				case 'personal':
					$segment_id = 1;
					break;
				case 'business':
					$segment_id = 4;
					break;
				case 'filip':
					$segment_id = 5;
					break;
			}
			Session::instance()->set('navclass', $el[0]);
			Session::instance()->set('segment', $segment_id);
			Session::instance()->delete('menu_active2');
			Session::instance()->delete('menu_active3');
			Session::instance()->set('menu_active', $element);
		}
	}

	public function action_set_active2()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$element = Arr::get($this->request->post(), 'element');

			Session::instance()->delete('menu_active');
			Session::instance()->delete('menu_active3');
			Session::instance()->delete('navclass');
			Session::instance()->delete('segment');
			Session::instance()->set('menu_active2', $element);
		}
	}

	public function action_set_active3()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$element = Arr::get($this->request->post(), 'element');

			Session::instance()->delete('menu_active');
			Session::instance()->delete('menu_active2');
			Session::instance()->delete('navclass');
			Session::instance()->delete('segment');
			Session::instance()->set('menu_active3', $element);
		}
	}
}