<?php defined('SYSPATH') or die('No direct script access.');

class Task_Cron extends Minion_Task {

	// auto archive published pages after it's end date
	protected function _execute(array $params)
	{
		$current_date = date('Y-m-d', time());
		$status_date = date('Ymd h:i:s A', time());

		/** AUTO ARCHIVE **/
		//get pages where status is published and end date is less than the current date
		$qry = DB::select()
			->from('pages')
			->where('status', '=', 'published')
			->where('end_date', '<', $current_date)
			->execute();

		// echo Database::instance()->last_query;
		// exit;
		if ($qry->count())
		{
			DB::update('pages')
				->set(array('status'=>'archived', 'status_date'=>$status_date))
				->where('status', '=', 'published')
				->where('end_date', '<', $current_date)
				->execute();

			// echo 'Finish Auto Archive';
		}

		// Delete Create Copy articles that was not completed
		DB::delete('pages')
			->where('status', '=', 'create-new-copy')
			->where('control_no', 'IS', NULL)
			->execute();

		// Mark superseded page as Archived once the page superseding it becomes active
		$qry = DB::select()
			->from('pages')
			->where('status', '=', 'published')
			->where('start_date', '<=', $current_date)
			->where('control_no_supersede', 'IS NOT', NULL)
			->where('cron_status', 'IS', NULL)
			->as_object()
			->execute();
		foreach($qry as $res)
		{
			$page_id = $res->id;
			$copy_from = $res->copy_from;
			$control_no = $res->control_no;

			$p = ORM::factory('Page')
				->where('status', '=', 'published')
				->where('id', '=', $copy_from)
				->find();
			if ($p->loaded())
			{
				$p->status = 'archived';
				$p->status_date = date('Ymd h:i:s A', time());
				$p->save();

				// mark also the media files status as archived in the media table
				DB::update('media')
					->set(array('page_status'=>'archived'))
					->where('page_id', '=', $copy_from)
					->execute();
			}
			unset($p);

			// mark the record's cron_status to 'Y' which means it has been processed
			DB::update('pages')
				->set(array('cron_status'=>'Y'))
				->where('id', '=', $page_id)
				->execute();
		}
	}
}