<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Misc extends Controller_Template {

	public $template = 'template/admin_tpl';

	public function before()
	{
		parent::before();

		$this->session = Session::instance();

		//checking ifAdministrator is logged in
		if( ! $this->session->get('user_id'))
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}

		$this->template->navmenu = View::factory('nav/main');
	}

	public function action_change_pw()
	{
		$nav = 'changepw';
		if ($this->session->get('nav_link') != $nav)
		{
			$this->session->set('nav_link', $nav);
		}

		$user_id = $this->session->get('user_id');

		$sql = ORM::factory('Admin', $user_id);

		if ($sql->loaded())
		{
			$data = array(
				'user_id' => $sql->id,
				'username' => $sql->username,
				'password' => $sql->password
			);
			$this->template->content = View::factory('admin/users/change_pw');
			$this->template->content->data = $data;
		}
		else
		{
			throw HTTP_Exception::factory(403, 'Unable to load the page!');
		}
	}

	public function action_update_pw()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');

			if (Security::check($token))
			{
				$user_id = Arr::get($this->request->post(), 'user_id');
				$username = Arr::get($this->request->post(), 'username');
				$old_password = Arr::get($this->request->post(), 'old_password');
				$old_password = crypt($old_password, Cookie::$salt);
				$new_password = Arr::get($this->request->post(), 'new_password');
				$new_password = crypt($new_password, Cookie::$salt);

				$sql = ORM::factory('Admin')
					->where('username', '=', $username)
					->where('password', '=', $old_password)
					->find();
				if ($sql->loaded())
				{
					$user = ORM::factory('Admin', $sql->id);
					$user->password = $new_password;
					$user->password_update_date = date('Y-m-d H:i:s', time());
					$user->save();
					unset($user);

					$this->redirect('admin/misc/pw_changed');
				}
			}
		}
		else
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}
	}

	public function action_check_pw()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$username = Arr::get($this->request->post(), 'username');
			$old_password = Arr::get($this->request->post(), 'old_password');
			$old_password = crypt($old_password, Cookie::$salt);

			$user = ORM::factory('Admin')
				->where('username', '=', $username)
				->where('password', '=', $old_password)
				->find();

			$result = TRUE;
			if ($user->loaded())
			{
				// check last update date for the password,
				// if changed within the day, return an error.
				$password_update_date = $user->password_update_date ? strtotime($user->password_update_date) : 0;
				$current_time = time();

				if (($current_time - $password_update_date) < 86400)
				{
					$result = FALSE;
				}

				echo json_encode($result);
			}
			else
			{
				echo json_encode(FALSE);
			}
		}
	}

	public function action_pw_changed()
	{
		$this->template->content = '<h3>Your password has been successfully updated.</h3>';
	}
}