<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Ads extends Controller {

	public function before()
	{
		parent::before();

		// $this->filesite = Kohana::$config->load('site')->get('dbserver');
	}

	public function action_get()
	{
		$keyword = urldecode($this->request->param('id'));

		$str_category = '';
		$str_sub_category1 = '';
		$str_sub_category2 = '';
		$str_sub_category3 = '';

		// exclude Logout Ad Banner
		$sql = DB::select('id')
			->from('categories')
			->where('name', 'LIKE', '%logout%')
			->as_object()
			->execute();

		$arr_categories = array();
		foreach ($sql as $res)
		{
			$arr_categories[0][] = $res->id;
		}

		$logout_category = '';
		foreach ($arr_categories as $level => $arr_categs)
		{
			if ($level == 0)
			{
				$logout_category = implode(",", $arr_categs);
			}
		}

		if ($keyword)
		{
			// get list of categories matching the keyword
			$sql = DB::select('id')
				->from('categories')
				->where('name', 'LIKE', '%'.$keyword.'%')
				->as_object()
				->execute();

			$arr_categories = array();
			foreach ($sql as $res)
			{
				$arr_categories[0][] = $res->id;
			}

			// get list from navtree matching the keyword
			$sql = DB::select('id','level')
				->from('navtree')
				->where('name', 'LIKE', '%'.$keyword.'%')
				->as_object()
				->execute();

			foreach ($sql as $res)
			{
				$level = $res->level;
				$arr_categories[$level][] = $res->id;
			}

			foreach ($arr_categories as $level => $arr_categs)
			{
				if ($level == 0)
				{
					$str_category = implode(",", $arr_categs);
				} else if ($level == 1) {
					$str_sub_category1 = implode(",", $arr_categs);
				} else if ($level == 2) {
					$str_sub_category2 = implode(",", $arr_categs);
				} else if ($level == 3) {
					$str_sub_category3 = implode(",", $arr_categs);
				}
			}
		}

		$current_date = date('Y-m-d', time());

		/*
		$sql = ORM::factory('Page')
			->where('content_type_id', '=', 3)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->where_close()
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date);
		*/
		$sql = "SELECT TOP 3 * FROM pages WHERE pages.content_type_id = 3
			AND (pages.status = 'published' OR pages.status = 'request-archive' OR pages.status = 'pending-archive' OR pages.status = 'check-archive' OR pages.status = 'rework-archive')
			AND pages.start_date <= '$current_date'
			AND pages.end_date >= '$current_date'";

		if ($logout_category)
		{
			$sql .= " AND pages.category_id NOT IN ($logout_category)";
		}

		if ($str_category OR $str_sub_category1 OR $str_sub_category2 OR $str_sub_category3)
		{
			$subq = '';
			if ($str_category)
			{
				// $sql->where('category_id', 'IN', DB::expr('('.$str_category.')'));
				$subq .= ($subq ? " OR " : '')." pages.category_id IN ($str_category)";
			}

			if ($str_sub_category1)
			{
				// $sql->where('sub_category1', 'IN', DB::expr('('.$str_sub_category1.')'));
				$subq .= ($subq ? " OR " : '')." pages.sub_category1 IN ($str_sub_category1)";
			}
			/*
			else
			{
				$sql .= " AND (pages.sub_category1 IS NULL OR pages.sub_category1 = 0)";
			}
			*/

			if ($str_sub_category2)
			{
				// $sql->where('sub_category2', 'IN', DB::expr('('.$str_sub_category2.')'));
				$subq .= ($subq ? " OR " : '')." pages.sub_category2 IN ($str_sub_category2)";
			}
			/*
			else
			{
				$sql .= " AND (pages.sub_category2 IS NULL OR pages.sub_category2 = 0)";
			}
			*/

			if ($str_sub_category3)
			{
				// $sql->where('sub_category3', 'IN', DB::expr('('.$str_sub_category3.')'));
				$subq .= ($subq ? " OR " : '')." pages.sub_category3 IN ($str_sub_category3)";
			}
			/*
			else
			{
				$sql .= " AND (pages.sub_category3 IS NULL OR pages.sub_category3 = 0)";
			}
			*/

			$sql .= $subq ? " AND (".$subq.")" : '';
		}

		// $sql .= " AND (ABS(CAST((BINARY_CHECKSUM(*) * RAND()) as int)) % 100) < 70";
		$sql .= " ORDER BY NEWID()";
		$query = DB::query(Database::SELECT, $sql);
		$qry = $query->as_object()->execute();

		// $qry = $sql->limit(3)->order_by(DB::expr('RAND()'))->find_all();
		// echo Database::instance()->last_query;
		$adview = '';
		if ($qry->count())
		{
			$ad_view = NULL;
			foreach ($qry as $ad)
			{
				$tpl_id = $ad->template_id;

				if ($tpl_id)
				{
					$t = ORM::factory('Template')
						->where('id', '=', $tpl_id)
						->where('content_type_id', '=', 3)
						->find();
					if ($t->id)
					{
						// Since this is an Ad, fields are pre defined
						$ad_view = View::factory('templates/'.$t->file_name);
						$ad_view->ad_link = $ad->link1 ? $ad->link1 : '';
						$ad_view->ad_src = URL::site('media/uploads/'.$ad->image1);
						$ad_view->target = "_top";
						// $ad_view->ad_src = $this->filesite.'/media/uploads/'.$ad->image1;
						// $ad_view->image1 = '<a href="'.$ad->link1.'"><img src="'.URL::site('media/uploads/'.$ad->image1).'"></a>';
						$ad_view->title = html_entity_decode($ad->title);

						$adview .= $ad_view;
					}
				}
			}
		}

		$adlist = "<div style=\"width:200px; height:auto; padding:0;\">".$adview."</div>";

		$this->response->body($adlist);
	}

	/**
	 * Get ad banner based on it's category/sub_category assignment
	 * @return [type] [description]
	 */
	public function action_random()
	{
		$params = $this->request->query();
		$category_id = Arr::get($params, 'category_id');
		$sub_category1 = Arr::get($params, 'sub_category1');
		$sub_category2 = Arr::get($params, 'sub_category2');
		$sub_category3 = Arr::get($params, 'sub_category3');

		$current_date = date('Y-m-d', time());
		$sql = "SELECT TOP 3 * FROM pages WHERE content_type_id = 3
			AND (status = 'published' OR status = 'request-archive' OR status = 'pending-archive' OR status = 'check-archive' OR status = 'rework-archive')
			AND start_date <= '$current_date'
			AND end_date >= '$current_date'
			AND category_id = $category_id";
		/*
		if ($sub_category1 > 0)
		{
			// $sql->where('sub_category1', '=', $sub_category1);
			$sql .= " AND sub_category1 = $sub_category1";
		} else {
			$sql .= " AND (sub_category1 IS NULL OR sub_category1 = 0)";
		}

		if ($sub_category2 > 0)
		{
			// $sql->where('sub_category2', '=', $sub_category2);
			$sql .= " AND sub_category2 = $sub_category2";
		} else {
			$sql .= " AND (sub_category2 IS NULL OR sub_category2 = 0)";
		}
		if ($sub_category3 > 0)
		{
			// $sql->where('sub_category3', '=', $sub_category3);
			$sql .= " AND sub_category3 = $sub_category3";
		} else {
			$sql .= " AND (sub_category3 IS NULL OR sub_category3 = 0)";
		}
		*/
		// $sql->where("(ABS(CAST((BINARY_CHECKSUM(*) * RAND()) as int)) % 100)", "<", 50);
		// $sql = $sql->find_all();

		// $sql .= " AND (ABS(CAST((BINARY_CHECKSUM(*) * RAND()) as int)) % 100) < 90";
		$sql .= " ORDER BY NEWID()";
		$query = DB::query(Database::SELECT, $sql);
		$qry = $query->as_object()->execute();

		$adview = NULL;
		if ($qry->count())
		{
			foreach ($qry as $ad)
			{
				$tpl_id = $ad->template_id;

				if ($tpl_id)
				{
					$t = ORM::factory('Template')
						->where('id', '=', $tpl_id)
						->where('content_type_id', '=', 3)
						->find();
					if ($t->id)
					{
						// Since this is an Ad, fields are pre defined
						$ad_view = View::factory('templates/'.$t->file_name);
						$ad_view->ad_link = $ad->link1 ? $ad->link1 : '';
						$ad_view->ad_src = URL::site('media/uploads/'.$ad->image1);
						// $ad_view->ad_src = $this->filesite.'/media/uploads/'.$ad->image1;
						/*
						$ad_view->image1 = '<a href="'.$ad->link1.'"><img src="'.URL::site('media/uploads/'.$ad->image1).'"></a>';
						*/
						$ad_view->title = html_entity_decode($ad->title);

						$adview .= $ad_view;
					}
				}
			}
		}

		$this->response->body($adview);
	}

	public function action_random2()
	{
		$keyword = urldecode($this->request->param('id'));

		$str_category = '';
		if ($keyword)
		{
			// get list of categories matching the keyword
			$sql = DB::select('id')
				->from('categories')
				->where('name', 'LIKE', '%'.$keyword.'%')
				->as_object()
				->execute();

			$arr_categories = array();
			foreach ($sql as $res)
			{
				$arr_categories[0][] = $res->id;
			}

			foreach ($arr_categories as $level => $arr_categs)
			{
				if ($level == 0)
				{
					$str_category = implode(",", $arr_categs);
				}
			}
		}

		$current_date = date('Y-m-d', time());

		$sql = "SELECT TOP 3 * FROM pages WHERE pages.content_type_id = 3
			AND (pages.status = 'published' OR pages.status = 'request-archive' OR pages.status = 'pending-archive' OR pages.status = 'check-archive' OR pages.status = 'rework-archive')
			AND pages.start_date <= '$current_date'
			AND pages.end_date >= '$current_date'";

		if ($str_category)
		{
			if ($str_category)
			{
				// $sql->where('category_id', 'IN', DB::expr('('.$str_category.')'));
				$sql .= " AND pages.category_id NOT IN ($str_category)";
			}
		}

		// $sql .= " AND (ABS(CAST((BINARY_CHECKSUM(*) * RAND()) as int)) % 100) < 70";
		$sql .= " ORDER BY NEWID()";
		$query = DB::query(Database::SELECT, $sql);
		$qry = $query->as_object()->execute();

		// $qry = $sql->limit(3)->order_by(DB::expr('RAND()'))->find_all();
		// echo Database::instance()->last_query;

		$adview = '';
		if ($qry->count())
		{
			$ad_view = NULL;
			foreach ($qry as $ad)
			{
				$tpl_id = $ad->template_id;

				if ($tpl_id)
				{
					$t = ORM::factory('Template')
						->where('id', '=', $tpl_id)
						->where('content_type_id', '=', 3)
						->find();
					if ($t->id)
					{
						// Since this is an Ad, fields are pre defined
						$ad_view = View::factory('templates/'.$t->file_name);
						$ad_view->ad_link = $ad->link1 ? $ad->link1 : '';
						$ad_view->ad_src = URL::site('media/uploads/'.$ad->image1);
						// $ad_view->ad_src = $this->filesite.'/media/uploads/'.$ad->image1;
						// $ad_view->image1 = '<a href="'.$ad->link1.'"><img src="'.URL::site('media/uploads/'.$ad->image1).'"></a>';
						$ad_view->title = html_entity_decode($ad->title);

						$adview .= $ad_view;
					}
				}
			}
		}

		$adlist = "<div style=\"width:200px; height:auto; padding:0;\">".$adview."</div>";

		$this->response->body($adlist);
	}

	public function action_logout()
	{
		$keyword = urldecode($this->request->param('id'));

		if ($keyword)
		{
			// get list of categories matching the keyword
			$sql = DB::select('id')
				->from('categories')
				// ->where('name', 'LIKE', '%'.$keyword.'%')
				->where('name', 'LIKE', '%'.$keyword.'%')
				->as_object()
				->execute();

			$arr_categories = array();
			foreach ($sql as $res)
			{
				$arr_categories[0][] = $res->id;
			}

			$str_category = '';

			foreach ($arr_categories as $level => $arr_categs)
			{
				if ($level == 0)
				{
					$str_category = implode(",", $arr_categs);
				}
			}

			$current_date = date('Y-m-d', time());

			$sql = "SELECT TOP 1 * FROM pages WHERE pages.content_type_id = 3
				AND (pages.status = 'published' OR pages.status = 'request-archive' OR pages.status = 'pending-archive' OR pages.status = 'check-archive' OR pages.status = 'rework-archive')
				AND pages.start_date <= '$current_date'
				AND pages.end_date >= '$current_date'";

			if ($str_category)
			{
				if ($str_category)
				{
					// $sql->where('category_id', 'IN', DB::expr('('.$str_category.')'));
					$sql .= " AND pages.category_id IN ($str_category)";
				}
			}

			// $sql .= " AND (ABS(CAST((BINARY_CHECKSUM(*) * RAND()) as int)) % 100) < 70";
			$sql .= " ORDER BY NEWID()";
			$query = DB::query(Database::SELECT, $sql);
			$qry = $query->as_object()->execute();

			// $qry = $sql->limit(3)->order_by(DB::expr('RAND()'))->find_all();
			// echo Database::instance()->last_query;
			$adview = '';
			if ($qry->count())
			{
				$ad_view = NULL;
				$ad = $qry->current();
				$tpl_id = $ad->template_id;

				if ($tpl_id)
				{
					$t = ORM::factory('Template')
						->where('id', '=', $tpl_id)
						->where('content_type_id', '=', 3)
						->find();
					if ($t->id)
					{
						// Since this is an Ad, fields are pre defined
						$header_footer = $t->header_footer;
						$ad_view = View::factory('templates/'.$t->file_name);
						$ad_view->ad_link = $ad->link1 ? $ad->link1 : '';
						$ad_view->ad_src = URL::site('media/uploads/'.$ad->image1);
						// $ad_view->ad_src = $this->filesite.'/media/uploads/'.$ad->image1;
						// $ad_view->image1 = '<a href="'.$ad->link1.'"><img src="'.URL::site('media/uploads/'.$ad->image1).'"></a>';
						$ad_view->title = html_entity_decode($ad->title);

						if ($header_footer == 2)
						{
							$view = View::factory('template/body_tpl');
						} else {
							$view = View::factory('template/main_tpl');
						}

						$view->content = $ad_view;
					}
				}
			}

			$this->response->body($view);
		}
	}

	/**
	 * Ad Banner script based on the page id[s]
	 * @return [type] [description]
	 */
	public function action_view()
	{
		$params = $this->request->query();
		$page_ids = Arr::get($params, 'page_ids');

		if ($page_ids)
		{
			$current_date = date('Y-m-d', time());
			$sql = ORM::factory('Page')
				->where('content_type_id', '=', 3)
				->where_open()
				->where('status', '=', 'published')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'pending-archive')
				->where_close()
				->where('start_date', '<=', $current_date)
				->where('end_date', '>=', $current_date)
				->where('id', 'IN', DB::expr('('.$page_ids.')'))
				->find_all();
			if ($sql->count())
			{
				$adview = '';
				foreach ($sql as $ad)
				{
					$tpl_id = $ad->template_id;

					if ($tpl_id)
					{
						$t = ORM::factory('Template', $tpl_id);
						if ($t->id)
						{
							// Since this is an Ad, fields are pre defined
							$ad_view = View::factory('templates/'.$t->file_name);
							$ad_view->image1 = '<a href="'.$ad->link1.'"><img src="'.URL::site('media/uploads/'.$ad->image1).'"></a>';
							// $ad_view->image1 = '<a href="'.$ad->link1.'"><img src="'.$this->filesite.'/media/uploads/'.$ad->image1.'"></a>';
							$ad_view->title = html_entity_decode($ad->title);

							$adview .= $ad_view;
						} else {
							$adview .= '<p><a href="'.$ad->link1.'"><img src="'.URL::site('media/uploads/'.$ad->image1).'"></a></p>';
							// $adview .= '<p><a href="'.$ad->link1.'"><img src="'.$this->filesiite.'/media/uploads/'.$ad->image1.'"></a></p>';
						}
					} else {
						$adview .= '<a href="'.$ad->link1.'"><img src="'.URL::site('media/uploads/'.$ad->image1).'"></a>'.($adview ? "<br />" : "");
						// $adview .= '<a href="'.$ad->link1.'"><img src="'.$this->filesite.'/media/uploads/'.$ad->image1.'"></a>'.($adview ? "<br />" : "");
					}
				}

				$this->response->body($adview);
			}
		}
	}
}